﻿using DE.TestFramework;
using Microsoft.Deployment.WindowsInstaller;
using System;
using System.Collections;

namespace DE.Tests
{
    partial class ICE_DE_20
    {
        [ICETest]
        public void TestForMalformedProductVersion()
        {
            const string validProductVersionMessage = "The ProductVersion property is valid.";
            const string invalidProductVersionMessage = "The ProductVersion property is invalid. Please refer to the MSI SDK for more information.";

            string productVersion = GetPropertyFromTable("ProductVersion");

            bool validProductVersion = true;

            Publish(ICELevel.Information, "Validating ProductVersion '" + productVersion + "'...");

            ArrayList productVersionFields = new ArrayList(productVersion.Split(new char[] { '.' }));

            if (productVersionFields.Count < 3)
            {
                validProductVersion = false;
            }
            else
            {
                try
                {
                    int major = int.Parse(productVersionFields[0].ToString());
                    int minor = int.Parse(productVersionFields[1].ToString());
                    int build = int.Parse(productVersionFields[2].ToString());
                }
                catch
                {
                    validProductVersion = false;
                }

            }

            if (validProductVersion)
            {
                Publish(ICELevel.Information, validProductVersionMessage);
            }
            else
            {
                Publish(ICELevel.Error, 
                        invalidProductVersionMessage,  
                        "http://msdn.microsoft.com/en-us/library/aa370859(VS.85).aspx",
                        "Property", 
                        "Property", 
                        "ProductVersion" );
            }
        }
    }
}
